# NOTE: Derived from ./blib/lib/VcsTools/DataSpec/HpTnd.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package VcsTools::DataSpec::HpTnd;

#line 334 "./blib/lib/VcsTools/DataSpec/HpTnd.pm (autosplit into ./blib/lib/auto/VcsTools/DataSpec/HpTnd/analyseLog.al)"
# returns a hash ref containing all extracted infos
sub analyseLog
  {
    my $self = shift ;
    my $log = shift ;

    my %info = ();

    my ($revision,$line) ;
    

  MAINLOOP: while()
    {
      $line = shift @$log ;
      last unless defined $line ;

      chomp($line) ;

      if ($line =~ /^revision\s*([\d.]+)$/) 
        {
          $revision = $1 ; 
          next ;
        }

      if (defined $revision)
        {
          # official HMS fields
          if ($line =~ /date:\s*(.*?);\s*author:\s*(\w+);\s*state:\s*(\w+)/) 
            {
              $info{$revision}{date} = $1;
              $info{$revision}{state} = $3;
            }
          elsif ($line =~ /^branches:\s*(.*)$/)
            {
              my @branches = split (/\s*;\s*/,$1) ;
              $info{$revision}{branches} = \@branches ;
            }
          elsif ($line =~ /^Author:\s*(.*)$/)
            {
              $info{$revision}{author} = $1 ;
            }
          # user defined convention
          elsif ($self->scanLogLine(\%info,$revision,$line))
            {
              next ;
            }
#           # STS bugs storage
#           elsif ($line =~ /^bugs fixed :\s*(.*)$/)
#             {
#               my $blankLines = 0 ;
#               my $bugLine ;
#               while ($bugLine = shift @$log)
#                 {
#                   if ($bugLine =~ /^\s*$/)
#                     {
#                       $blankLines++ ;
#                       next MAINLOOP if $blankLines == 2;
#                     }
#                   elsif ($bugLine =~ /^\s+-\s+(GREhp\d+)\s*:\s*(.*)$/)
#                     {
#                       $info{$revision}{stsBugs}{$1} = $2 ;
#                     }
#                   else
#                     {
#                       # none case
#                       next MAINLOOP;
#                     }
#                 } 
#             }

          # try to get something out of it 
          elsif ($line !~ /^[-=]+$/ )
            {
              if ($line =~ /(GREhp\d+)/ and 
                  not defined $info{$revision}{fix})
                {
                  $info{$revision}{guessedFix}{$1} = 1 ;
                }
              if ($line =~ /\b([A-Z\d]{2,})\b/ and 
                  not defined $info{$revision}{keywords})
                {
                  $info{$revision}{guessedKeywords}{$1}= 1 ;
                }
              $info{$revision}{'log'} .= $line."\n";
            }
        }
#       else
#         {
#           if ($line =~ /^rev:/)
#             {
#               my ($rev,$locker) = 
#                 ( $line =~ /rev:\s*(.*?);\s*locked by:\s*(.*?);/);
#               $info{'lock'}{$rev} = $locker ;
#             }
#         }
    }
    
    
    foreach my $rev (keys %info)
      {
        # set writer as author by default of previous version
        if (defined $info{$rev}{author} and not defined $info{$rev}{writer})
          {
            $info{$rev}{writer} = $info{$rev}{author};
          }
        if (defined $info{$rev}{guessedKeywords} and 
            not defined $info{$rev}{keywords})
          {
            $info{$rev}{keywords} = 
              [sort keys %{$info{$rev}{guessedKeywords}}];
          }
        if (defined $info{$rev}{stsBugs} and 
            not defined $info{$rev}{fix})
          {
            $info{$rev}{fix} = [sort keys %{$info{$rev} {stsBugs}}];
          }
        if (defined $info{$rev}{guessedFix} and not defined $info{$rev}{fix})
          {
            $info{$rev}{fix} = [sort keys %{$info{$rev} {guessedFix}}];
          }

        # cleanup (but don't delete stsBugs
        delete $info{$rev} {guessedKeywords};
        delete $info{$rev} {guessedFix};
      }

    $self->{info} = \%info ;
    return \%info ;
  }

# end of VcsTools::DataSpec::HpTnd::analyseLog
1;
