# NOTE: Derived from ./blib/lib/VcsTools/File.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package VcsTools::File;

#line 532 "./blib/lib/VcsTools/File.pm (autosplit into ./blib/lib/auto/VcsTools/File/archiveFile.al)"
sub archiveFile 
  {
    my $self = shift ;
    my $infoRef = shift ;
    my $version = shift || $self->{revision} ;

    die "No version passed to archive of $self->{name}\n"
      unless defined $version ;

    $self->printEvent("Archiving history for revision $version\n");

    die "File $self->{name}: Can't archive non writable file\n" unless
      $self->{writable} ;

    $self->createHistory() unless defined $self->{history} ;

    $self->display ;

    my $f = $self->{tk}{toplevel} -> 
      Frame (relief => 'sunken', 'borderwidth' => 2 ) 
        ->pack(qw/fill x/);

    $f -> Label (text => "Archiving $self->{name} from version $version") 
      -> pack;

    my $bf = $f -> Frame -> pack(qw/fill x/) ;

    my $newRev = $self->guessNewRev($self->{revision}) ;

    $bf -> Entry (textvariable => \$newRev, width=> 6) 
      -> pack (qw/side right fill x expand 1/) ;

    $bf -> Label (text => "in version: ") -> pack (side => 'right');
    
    $bf -> Button 
      (
       'text' => 'do archive',
       'command' => sub 
       {
         $self->{history}->archive
           (
            revision=> $newRev, 
            'info' => $infoRef 
           ) ;
       }
      ) -> pack (side => 'left' ) ;

    $bf -> Button 
      (
       'text' => 'show diff',
       'command' => 
       sub { $self-> showDiff( rev1 => $version,
                             callback => sub {$self->showResult(@_)}) ;}
      ) -> pack (side => 'left' ) ;

    $bf -> Button 
      (
       'text' => 'done',
       'command' => sub { $f-> destroy ; }
      ) -> pack (side => 'right' ) ;

  }

# internal
# end of VcsTools::File::archiveFile
1;
