# NOTE: Derived from ./blib/lib/VcsTools/File.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package VcsTools::File;

#line 1129 "./blib/lib/VcsTools/File.pm (autosplit into ./blib/lib/auto/VcsTools/File/merge.al)"
sub merge
  {
    my $self = shift ;
    my $rev1 = shift ;
    my $rev2 = shift ;

    die "$self->{name}::merge rev1 or rev2 are not defined\n" unless 
      defined $rev1 and defined $rev2 ;

    $self->display() ;
    $self->createHistory() unless defined $self->{history} ;

    # get rev1 object
    my $obj1 = $self->{history}->getVersionObj($rev1) ;
    my $ancestor = $obj1->findAncestor($rev2);

    my $f = $self->{tk}{toplevel} ->
      Frame(relief => 'sunken', 'borderwidth' => 2 ) ->pack(fill => 'x') ;

    my $lf = $f -> Frame -> pack ;
    $lf -> Label
      (text => "Merging file $self->{name} $rev1 with $rev2 from $ancestor")
      -> pack (side => 'left') ;

    my ($below, $newRev, $other);
    my ($archiveB, $ediffB, $checkOutB,@belowWidgets)   ;

    my $belowf = $f -> Frame -> pack(fill => 'x') ;
    $belowf ->Label (text => "merge below :") -> pack (side => 'left');

    my $buttonf = $f -> Frame -> pack ;

    $archiveB = $buttonf -> Button
      (
       text => 'archive merge' ,
       state => 'disabled',
       command =>
       sub
       {
         $self->createHistory() unless defined $self->{history} ;
         my $info = $self->{history}->buildCumulatedInfo($other,$ancestor);
         $info->{mergedFrom} = $other ;
         $self->{history}->archive
           (
            revision => $newRev,
            info => $info,
            callback => sub
            {
              $f->destroy ;
              $self->mergeCleanup() ;
            }
           ) ;
       }
      )
      -> pack (side => 'right');

    $ediffB = $buttonf -> Button
      (
       text => 'ediff' ,
       state => 'disabled',
       command => sub 
       { 
         $self->createFileAgent unless defined $self->{fileAgent} ;
         $self->{fileAgent}->merge
           (
            %{$self->{mergeFiles}},
            callback => sub 
            {
              my $res = shift ;
              if ($res) {$archiveB->configure(state => 'normal') ;}
              else {die "Ediff failed : ",shift(),"\n";}
            }
           ) ;
       }
      ) -> pack (side => 'right');

    $checkOutB = $buttonf -> Button 
      (
       text => 'check-out' ,
       state => 'disabled',
       command => sub 
       { 
         # must get 1 or 3 files and lock the current file
         my $cb = sub 
           {
             if (shift)
               {
                 if ($rev2 eq $ancestor or $rev1 eq $ancestor)
                   {$archiveB -> configure(state => 'normal') ;}
                 else 
                   {$ediffB -> configure(state => 'normal') ;}
                 $checkOutB -> configure(state => 'disabled') ;
                 map($_->configure(state => 'disabled'),@belowWidgets);
               }
             else
               {
                 die "Couldn't get files for merge ",shift,"\n";
               }
           };

         $other = $rev1 eq $below ? $rev2 : $rev1 
           unless $rev2 eq $ancestor or $rev1 eq $ancestor  ;

         $self->setUpMerge(callback =>$cb,
                           below => $below,
                           ancestor => $ancestor,
                           other => $other);
       }
      ) -> pack (side => 'right');

    
    if ($rev2 ne $ancestor and $rev1 ne $ancestor)
      {
        foreach ($rev1,$rev2)
          {
            # skip stupid choices
            next if ( ($_ eq $rev1 and $rev2 eq $ancestor) or
                      ($_ eq $rev2 and $rev1 eq $ancestor) ) ;

            push @belowWidgets, $belowf -> Radiobutton
              (
               text => $_, 
               value => $_, 
               variable => \$below,
               command => sub 
               {
                 $newRev = $self->guessNewRev($below); 
                 $checkOutB -> configure(state => 'normal');
               }
              ) -> pack (side => 'left');
          }
      }
    else
      {
        $below = $rev1 eq $ancestor ? $rev2 : $rev1 ;
        $newRev = $self->guessNewRev($below); 
        $checkOutB -> configure(state => 'normal');
      }

    $belowf ->Label (text => "in revision : ") -> pack (side => 'left');
    my $e = $belowf -> Entry 
      (
       textvariable => \$newRev,
      ) -> pack (qw/side left expand 1 fill x/ ) ;
    push @belowWidgets, $e ;

    $e->bind('<Return>' => sub{$checkOutB -> configure(state => 'normal');});
  }

# internal
# end of VcsTools::File::merge
1;
