# NOTE: Derived from ./blib/lib/VcsTools/File.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package VcsTools::File;

#line 636 "./blib/lib/VcsTools/File.pm (autosplit into ./blib/lib/auto/VcsTools/File/openHistory.al)"
sub openHistory
  {
    my $self = shift ;

    $self->createHistory() unless defined $self->{history} ;
    $self->{history}->display ;

    
    my $gmgr = $self->{history}->getGraphMgr ;

    $gmgr -> command
      (
       -label => 'merge', 
       command => sub 
       {
         my @revs = $gmgr->getSelectedNodes();
         if (defined @revs and scalar(@revs) == 2) {$self->merge (@revs);}
         else {print scalar(@revs)," nodes selected\n";}
       }
      );

    $gmgr -> command
      (
       -label => 'show diff', 
       command => sub 
       {
         my @revs = $gmgr->getSelectedNodes();
         if (defined @revs and scalar(@revs) == 2)
           {
             $self->showDiff
               ( 
                rev1 => $revs[0],
                rev2 => $revs[1],
                callback => sub {$self->{history}->showResult(@_) ;}
               );
           }
         else
           {
             print scalar(@revs)," nodes selected\n";
           }
       }
      );


    my $showDiff = sub 
      {
        $self->showDiff
          ( 
           rev1 => shift ,
           rev2 => shift ,
           callback => sub {$self->{history}->showResult(@_) ;}
          );
      } ;

    $gmgr->arrowBind('<2>','yellow',$showDiff);
    $gmgr->arrowCommand('show diff',$showDiff) ;


    # bind button <2> on nodes to show content
    $gmgr->nodeCommand
      (
       'show content',
       sub 
       {
         my $rev = shift ;
         $self->getContent(revision => $rev,
                           callback => sub{$self->{history}->showResult(@_);})
       }
      ) ;

  }

# end of VcsTools::File::openHistory
1;
