# NOTE: Derived from ./blib/lib/VcsTools/History.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package VcsTools::History;

#line 446 "./blib/lib/VcsTools/History.pm (autosplit into ./blib/lib/auto/VcsTools/History/archive.al)"
sub archive
  {
    my $self = shift ;
    my %args = @_ ;
    
    foreach (qw/revision/)
      {
        croak "No $_ passed to $self->{name}-> archive\n" unless
          defined $args{$_};
      }

    my $revision = $args{revision} ;

    croak "Can't archive an existing version ($args{revision})\n"
      if defined $self->{version}{$revision} ;
    
    # create new version object
    my $obj = $self->createVersionObj($revision) ;
    
    # store any info in this new object
    $obj->storeDbInfo($args{info}) if defined $args{info} ;

    # now edit the history of the new version
    $obj->editHistory
      (
       callback => sub
       {
         my $infoRef = shift ;
         my $str = $self->{dataScanner}->buildLogString($infoRef) ;
         $self->{manager}->checkIn
           (
            revision => $revision,
            'log' => \$str,
            state => $infoRef->{state},
            callback => sub
            {
              $self->archiveDone($args{callback},@_, $revision, $obj,$infoRef);
            }
           )
         }
      );

  }

#internal
# end of VcsTools::History::archive
1;
