# NOTE: Derived from ./blib/lib/VcsTools/History.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package VcsTools::History;

#line 575 "./blib/lib/VcsTools/History.pm (autosplit into ./blib/lib/auto/VcsTools/History/display.al)"
sub display
  {
    my $self = shift ;
    return unless $self->SUPER::display();

    require Tk::Menubutton;

    # create graph Manager
    my $gmgr = $self->{tk}{graphMgr} = 
      new VcsTools::GraphMgr
        (
         'name' => $self->{name},
         'multiMgr' => $self->{tk}{'multiMgr'},
         'help'=>sub{$self->showHelp('VcsTools::History','WIDGET USAGE')}
        ) ;
    
    $gmgr->addRev(@{$self->{myDbHash}{versionList}}) ;

    # a garder TBD ?
    my $textSlave = $self->{textObj} =
      $self->{tk}{multiMgr}->newSlave
        (
         'type' => 'MultiText', 
         'title' => $self->{name},
         'hidden' => 0 ,
         'help' => 'This text window display the results of the operations '.
         'invoked within the History graph widget'
        );


    # must add menu button related to the graph funcionnality
    # i.e draw, merge, show diff
    # these function will ask for currently selected nodes


    $gmgr->command(-label=>'unselect all', 
                   command => sub{$gmgr->unselectAllNodes();});

    $gmgr->command(-label=>'reload from archive', 
                   command => sub{$self->loadFromVcs();});

    $gmgr->command
      (
       -label=>'show cumulated log', 
       command => sub
       {
         my $info = $self->buildCumulatedInfo($gmgr->getSelectedNodes()) ;
         my $str = $self->{dataScanner}->buildLogString($info) ;
         $self->showResult(1,$self->{dataScanner}->buildLogString($info));
       }
      );

    $gmgr->listBind('<Double-1>' => sub 
                    {
                      my $item = shift ;
                      my $rev = $item->get ('active') ;
                      $self->printEvent("drawing tree from rev $rev\n") ;
                      $self->drawTree($rev) ;
                    }
                   ) ;

    my $showLog = sub 
      {
        my ($from,$to) = @_ ;
        my $str = $self->{content}{$to}->getSubLog() ;
        $self->showResult(1,$str) ;
      } ;
    
    my $showFullLog = sub 
      {
        my ($from,$to) = @_ ;
        my $ref = $self->{content}{$to}->getInfoRef() ;
        my $str = $self->{dataScanner}->buildLogString($ref) ;
        $self->showResult(1,$str) ;
      } ;
    
    $gmgr->arrowBind('<1>','red', $showLog) ;
    $gmgr->arrowCommand('show log', $showLog) ;
    $gmgr->arrowCommand('show full log', $showFullLog) ;
    

    $gmgr->arrowCommand('edit History',
                        sub
                        {
                          my  ($from,$to) = @_ ;
                          $self->{content}{$to}->editHistory() ;
                        }
                       );

    $gmgr->arrowBind('<3>','orange', sub {$gmgr->popupArrowMenu(@_);}) ;


    # bind double-1 to redraw the whole graph 
    $gmgr->nodeBind('<Double-1>','black', sub {$self->drawTree(@_)});

    # bind button <3> on nodes to edit history (redundant with arrow <3> )
    $gmgr->nodeBind('<3>','red', sub {$gmgr->popupNodeMenu(@_);}) ;
    $gmgr->nodeCommand('edit History',
                    sub {
                      my $rev = shift ;
                      $self->{content}{$rev}->editHistory() ;
                    }) ;

    $gmgr->nodeCommand('draw from here',sub {$self->drawTree(@_)});
    $gmgr->nodeCommand('open version object',sub {
                      my $rev = shift ;
                      $self->{content}{$rev}->display() ;
                    }) ;
  }

# end of VcsTools::History::display
1;
