# NOTE: Derived from ./blib/lib/VcsTools/History.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package VcsTools::History;

#line 333 "./blib/lib/VcsTools/History.pm (autosplit into ./blib/lib/auto/VcsTools/History/storeLog.al)"
sub storeLog
  {
    my $self = shift ;
    my $log = shift ; # array ref of log lines
    
    my $hash = $self->{dataScanner} -> analyseLog($log) ;
    # must add findUpperLeaves to add lower and upper informations
    #$self->findUpperLeaves($hash) ;
    
    # must destroy and re-create all relevant version object
    $self->dropAll();

    # version hash must have all revision as keys
    my @version = keys %$hash ;

    $self->storeDbInfo(versionList => \@version);

    # must clean up the old version list
    undef $self->{version} ;

    # create the version object and store relevant info in it
    foreach my $rev (@version)
      {
        $self->getVersionObj($rev)->storeLog($hash->{$rev}) ;
      }

    # verify if all (minus 1) versions have a parent ...
    my @orphan =();
    foreach my $v (@version)
      {
        unless ($self->{content}{$v}->hasParent)
          {
            $self->printEvent("Version $v has no previous version\n");
            push @orphan,$v;
          }
      }

    if (scalar @orphan > 1)
      {
        $self->printEvent
          ("Warning: $self->{name} has more than one revision without parent\n". join(' - ',@orphan)."\n") ;
        $self->showEvent();
      }
  }


# end of VcsTools::History::storeLog
1;
