# NOTE: Derived from ./blib/lib/VcsTools/Version.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package VcsTools::Version;

#line 218 "./blib/lib/VcsTools/Version.pm (autosplit into ./blib/lib/auto/VcsTools/Version/drawSubTree.al)"
sub drawSubTree
  {
    my $self = shift ;
    my $x = shift ;
    my $y = shift ;
    my $widthR = shift ;

    #ask manager the graphMgr ref
    $self->{graphMgr} = $self->{manager}->getGraphMgr() 
      unless defined $self->{graphMgr} ;

    my $rev = $self->{revision} ;
    my $dbHash = $self->{"myDbHash"} ;
    my $date = $dbHash->{'date'} || '';
    $date =~ s/ .*$//;

    # print "drawing $rev : x $x y $y widthR $$widthR\n";

    my @array = ($date) ;
    push @array, @{$dbHash->{keywords}} if defined $dbHash->{keywords};
    push @array, @{$dbHash->{fix}}      if defined $dbHash->{fix} ;

    $self->{graphMgr}->addNode($rev,\@array,\$x,\$y) ;

    # check if this node is a merge
    # we must store the info now, and draw them later on.
    if (defined $dbHash->{mergedFrom})
      {
        $self->{graphMgr}->addMergeInfo($rev,$dbHash->{mergedFrom}) ;
      }

    if (defined $dbHash->{lower})
      {
        my ($lx,$ly)=($x,$y);
        $self->{graphMgr}->addDirectArrow($rev,$dbHash->{lower},
                                          \$lx,\$ly);
        $self->{manager}->getVersionObj($dbHash->{lower}) 
          ->drawSubTree($lx, $ly, $widthR );
      }
    
    if (defined $dbHash->{branches})
      {
        foreach my $branch ( @{$dbHash->{branches}} )
          {
            my ($lx,$ly)=($x,$y);
            my $subWidth = 0;
            $self->{graphMgr}->addBranchArrow($rev,$branch,\$lx,\$ly,$widthR);
            $self->{manager}->getVersionObj($branch)
              ->drawSubTree( $lx ,$ly, \$subWidth );
            $$widthR += $subWidth ;
          }
      }
    # print "end     $rev : x $x y $y widthR $$widthR\n";
  }

# return 1 if a previous object was found, 0 if not
# end of VcsTools::Version::drawSubTree
1;
