# NOTE: Derived from ./blib/lib/VcsTools/Version.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package VcsTools::Version;

#line 274 "./blib/lib/VcsTools/Version.pm (autosplit into ./blib/lib/auto/VcsTools/Version/storeLog.al)"
sub storeLog
  {
    my $self = shift ;
    my $log = shift ; #hash ref
    
    # must update the info gotten from the log info
    my $tmp = $self->{revision} ;
    $tmp =~ s/(\d+)$/$1-1/e ; # decrement rev

    my $upperObj = $self->{manager}->getVersionObj($tmp) ;
    if (defined $upperObj )
      {
        if (defined $log->{previous})
          {
            die "Major problem: $self->{name} version $self->{revision} has ",
            "declared previous rev ", $log->{previous},
            " and implicit previous rev $tmp\n" 
              unless $tmp eq $log->{previous};
          }
        $log->{upper} = $tmp ;
        $upperObj->storeDbInfo(lower=> $self->{revision}) ;
      }
    elsif (defined $log->{previous})
      {
        my $prevObj = $self->{manager}->getVersionObj($log->{previous}) ;
        die "Major problem: $self->{name} version $self->{revision} has a ",
        "non-existent previous version $log->{previous}\n"
          unless defined $prevObj ;
        $log->{upper} = $log->{previous} ;
        $prevObj->storeDbInfo(lower=> $self->{revision}) ;
      }

    if (defined $log->{branches})
      {
        # find first rev of a branch (could be 4.1.1.0 or 4.1.1.1 where
        # stored branch is 4.1.1
        map 
          {
            $_ .= '.0' ;
            my $v;
            while (not defined ($v = $self->{manager}->getVersionObj($_)))
              {
                s/(\d+)$/$1+1/e ;
              };
            # actually stores the upper info
            $v->storeDbInfo (upper => $self->{revision}) ;
          }
        @{$log->{branches}} ;
      }

    if (defined $log->{mergedFrom})
      {
        my $otherObj = $self->{manager}->getVersionObj($log->{mergedFrom}) ;
        #my $upper = $log->{upper} ;
        #            $info->{mergeList}{"$upper-$other"} = $rev ;

        die "Non existant version $log->{mergedFrom} in mergedFrom field\n"
          unless defined $otherObj ;

        # emulate a push 
        my @array = defined $otherObj->{myDbHash}{mergedIn} ?
          @{$otherObj->{myDbHash}{mergedIn}} : () ;
        push @array, $self->{revision} ;
        $otherObj->storeDbInfo(mergedIn => \@array) ;
      }

    $self->storeDbInfo(%$log) ;
    
  }


# end of VcsTools::Version::storeLog
1;
